#include <pose.hpp>

using namespace QOSM;

Pose::Pose Pose::changeFrame(const Pose &pose_ref_a, const Pose &pose_ref_b){
    const Vec3 &ref_r_ref_a = pose_ref_a.ref_r_ref_ori;
    const Vec3 &ref_r_ref_b = pose_ref_b.ref_r_ref_ori;
    const Quaternion &q_ref_a = pose_ref_a.q_ref_ori;
    const Quaternion &q_ref_b = pose_ref_b.q_ref_ori;

    const Quaternion q_a_ref = q_ref_a.conj();
    const Quaternion q_a_b = q_a_ref * q_ref_b;
    const Vec3 ref_r_a_b = ref_r_ref_b - ref_r_ref_a;
    const Vec3 a_r_a_b = q_a_b.rotate(ref_r_a_b);

    return Pose(a_r_a_b, q_a_b);
}